#include <string.h>
#include <stdlib.h>
#include "network.h"
#include "draw.h"

static int imax2(int a,int b) { return a>b?a:b; }

void draw_network(network_t *NW,int xs, int ys, int cr, int lt,
                  int *Rw,int *Rh,unsigned int** Rd)
{
  int i;
  int max_x;
  pbuffer_t *B;
  compex_t *CE;
  int x1,y1,x2,y2,N;
  int w,h;
  unsigned int *data;
  point_t *p;
  unsigned int np;

  N= NW->ninputs;
  network_layout_for_drawing(NW);
  network_levels(NW);
  
  max_x= 0;
  for(i=0;i<NW->ngates;i++)
    max_x= imax2(NW->gates[i]->x,max_x);

  w= (max_x+4)*xs;
  h= (N+1)*ys;

  B= NULL;
  for(i=0;i<N;i++)
  {
    x1= xs;
    x2= (max_x+3)*xs;
    y1= (i+1)*ys;
    B= draw_thick_line(B,0x00,x1,y1,x2,y1, lt);
  }

  for(i=0;i<NW->ngates;i++)
  {
    CE= NW->gates[i];
    y1= (CE->A+1)*ys;
    y2= (CE->B+1)*ys;
    x1= (CE->x+2)*xs;
    B= draw_thick_line(B,CE->color,x1,y1,x1,y2,lt);
    B= draw_filled_circle(B,CE->color,x1,y1,cr);
    B= draw_filled_circle(B,CE->color,x1,y2,cr);
  }

  for(i=1;i<NW->ngates;i++)
    if (NW->gates[i]->level!=NW->gates[i-1]->level)
    {
      x1= (NW->gates[i]->x+2)*xs - xs/2;
      y1= ys/2;
      y2= N*ys+ys/2;
      B= line(B, 0xff, x1,y1, x1, y2);
    }


  pbuffer_get(B,&p,&np);
  pbuffer_free(B);
  data= malloc(w*h*sizeof(data[0]));
  for(i=0;i<w*h;i++) data[i]= 0xFFffFFff;
  for(i=0;i<np;i++)
  {
    x1= p[i].x; y1= p[i].y;
    if (x1>=0 && x1<w && y1>=0 && y1<h)
       data[x1+y1*w]= p[i].color | 0xFF000000;
  }
  free(p);

  *Rd= data;
  *Rw= w;
  *Rh= h;
}
